"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.convertOptionDefinition = void 0;
const errors_1 = require("./errors");
const convertOptionDefinition = function ({ optionDefinition }) {
    let type;
    if (optionDefinition.type === 'boolean' && optionDefinition.defaultOption) {
        throw new errors_1.errors.OptionInvalid(`Option '${optionDefinition.name}' must not be a default option, because it is boolean.`);
    }
    switch (optionDefinition.type) {
        case 'boolean':
            type = Boolean;
            break;
        case 'string':
            type = String;
            break;
        case 'number':
            type = Number;
            break;
        default:
            throw new errors_1.errors.InvalidOperation();
    }
    return {
        name: optionDefinition.name,
        alias: optionDefinition.alias,
        defaultOption: optionDefinition.defaultOption,
        defaultValue: optionDefinition.defaultValue,
        multiple: optionDefinition.multiple === 'on',
        lazyMultiple: optionDefinition.multiple === 'lazy',
        type
    };
};
exports.convertOptionDefinition = convertOptionDefinition;
